/[gentoo-x86]/eclass/gtk-sharp-module.eclass
Gentoo

Contents of /eclass/gtk-sharp-module.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.37 - (hide annotations) (download)
Sun Jan 19 21:13:08 2014 UTC (8 months, 1 week ago) by moult
Branch: MAIN
CVS Tags: HEAD
Changes since 1.36: +3 -3 lines
Change virtual/monodoc dependency to dev-lang/mono as the former is being
treecleaned (bug 471180)

1 moult 1.37 # Copyright 1999-2014 Gentoo Foundation
2 loki_val 1.1 # Distributed under the terms of the GNU General Public License v2
3 moult 1.37 # $Header: /var/cvsroot/gentoo-x86/eclass/gtk-sharp-module.eclass,v 1.36 2012/09/27 16:35:41 axs Exp $
4 loki_val 1.1
5 loki_val 1.14 # @ECLASS: gtk-sharp-module.eclass
6     # @MAINTAINER:
7     # dotnet@gentoo.org
8     # @BLURB: Manages the modules of the gtk-, gnome-, and gnome-desktop-sharp tarballs
9     # @DESCRIPTION:
10     # This eclass provides phase functions and helper functions for the modules
11     # of the gtk-sharp, gnome-sharp and gnome-desktop-sharp tarballs.
12     # PLEASE TAKE NOTE: ONLY FOR EAPI-2 EBUILDS
13 loki_val 1.1
14 loki_val 1.14 WANT_AUTOMAKE=none
15     WANT_AUTOCONF=none
16 loki_val 1.1
17 loki_val 1.24 inherit eutils mono multilib libtool autotools base versionator
18 loki_val 1.1
19 darkside 1.31 case ${EAPI:-0} in
20 axs 1.36 2|3|4|5) ;;
21 darkside 1.31 *) die "Unknown EAPI." ;;
22     esac
23    
24 loki_val 1.14 # @ECLASS-VARIABLE: GTK_SHARP_MODULE
25     # @DESCRIPTION:
26     # The name of the Gtk# module.
27     # Default value: ${PN/-sharp/}
28 loki_val 1.1 GTK_SHARP_MODULE=${GTK_SHARP_MODULE:=${PN/-sharp/}}
29 loki_val 1.14
30     # @ECLASS-VARIABLE: GTK_SHARP_MODULE_DIR
31     # @DESCRIPTION:
32     # The subdirectory of S in which GTK_SHARP_MODULE is installed.
33     # Default value: ${PN/-sharp/}
34 loki_val 1.1 GTK_SHARP_MODULE_DIR=${GTK_SHARP_MODULE_DIR:=${PN/-sharp/}}
35    
36 loki_val 1.14 # @ECLASS-VARIABLE: GTK_SHARP_REQUIRED_VERSION
37     # @DESCRIPTION:
38     # The version of the gtk-sharp tarball this package requires.
39     # Optional.
40     GTK_SHARP_REQUIRED_VERSION="${GTK_SHARP_REQUIRED_VERSION}"
41    
42     # @ECLASS-VARIABLE: gapi_users_list
43     # @DESCRIPTION:
44     # List of modules that use one of gapi2-codegen, gapi2-fixup or gapi2-parser
45     # No ebuild-serviceable parts inside.
46     gapi_users_list="art gnome gnomevfs ${gnome_desktop_sharp_module_list} atk gtk gdk glade pango"
47    
48     # @ECLASS-VARIABLE: PV_MAJOR
49     # @DESCRIPTION:
50     # The first two components of the PV variable.
51 loki_val 1.8 PV_MAJOR=$(get_version_component_range 1-2)
52    
53 loki_val 1.21 # @FUNCTION: add_bdepend
54 loki_val 1.14 # @USAGE: <package atom>
55     # @DESCRIPTION:
56     # Adds to the DEPEND variable
57 loki_val 1.8 add_bdepend() {
58 loki_val 1.14 [[ ${#@} -eq 1 ]] || die "${FUNCNAME} needs ONE (1) argument"
59 loki_val 1.8 DEPEND="${DEPEND} $@"
60     }
61    
62 loki_val 1.21 # @FUNCTION: add_rdepend
63 loki_val 1.14 # @USAGE: <package atom>
64     # @DESCRIPTION:
65     # Adds to the RDEPEND variable
66 loki_val 1.8 add_rdepend() {
67 loki_val 1.14 [[ ${#@} -eq 1 ]] || die "${FUNCNAME} needs ONE (1) argument"
68 loki_val 1.8 RDEPEND="${RDEPEND} $@"
69     }
70    
71 loki_val 1.14 # @FUNCTION: add_depend
72     # @USAGE: <package atom>
73     # @DESCRIPTION:
74     # Adds to the DEPEND and RDEPEND variables
75 loki_val 1.8 add_depend() {
76 loki_val 1.14 [[ ${#@} -eq 1 ]] || die "${FUNCNAME} needs ONE (1) argument"
77 loki_val 1.8 DEPEND="${DEPEND} $@"
78     RDEPEND="${RDEPEND} $@"
79     }
80    
81 loki_val 1.14 # @ECLASS-VARIABLE: TARBALL
82     # @DESCRIPTION:
83     # The GtkSharp modules are currently divided into three seperate tarball
84     # distributions. The TARBALL variable holds the name of the tarball
85     # to which GTK_SHARP_MODULE belongs.
86     case ${GTK_SHARP_MODULE} in
87     glib|glade|gtk|gdk|atk|pango|gtk-dotnet|gtk-gapi|gtk-docs)
88     TARBALL="gtk-sharp"
89     case ${PVR} in
90 loki_val 1.15 2.12.*)
91 loki_val 1.19 SRC_URI="mirror://gentoo/${TARBALL}-2.12.7.patch.bz2"
92 loki_val 1.14 #Upstream: https://bugzilla.novell.com/show_bug.cgi?id=$bugno
93     #Upstream bug #470390 for the gtk-sharp-2.12.7.patch
94 loki_val 1.15 PATCHES=(
95     "${WORKDIR}/${TARBALL}-2.12.7.patch"
96     )
97 loki_val 1.14 EAUTORECONF="YES"
98     add_bdepend "=sys-devel/automake-1.10*"
99     add_bdepend ">=sys-devel/autoconf-2.61"
100     ;;
101     esac
102     ;;
103     art|gnome|gnomevfs|gconf)
104     TARBALL="gnome-sharp"
105     add_depend "=dev-dotnet/gtk-sharp-${GTK_SHARP_REQUIRED_VERSION}*"
106     has "${GTK_SHARP_MODULE}" "${gapi_users_list}" && \
107     add_bdepend "=dev-dotnet/gtk-sharp-gapi-${GTK_SHARP_REQUIRED_VERSION}*"
108 loki_val 1.19 case ${PVR} in
109     2.24.1*)
110     SRC_URI="mirror://gentoo/${TARBALL}-2.24.1.patch.bz2"
111 loki_val 1.20 # Upstream bug: https://bugzilla.novell.com/show_bug.cgi?id=483251
112 loki_val 1.19 PATCHES=(
113     "${WORKDIR}/${TARBALL}-2.24.1.patch"
114     )
115     EAUTORECONF="YES"
116     add_bdepend "=sys-devel/automake-1.10*"
117     add_bdepend ">=sys-devel/autoconf-2.61"
118     ;;
119 pacho 1.27 2.24.2*)
120     add_depend ">=dev-lang/mono-2.7"
121     ;;
122 loki_val 1.19 esac
123 loki_val 1.14 ;;
124     gnome-desktop|gnome-print|gnome-panel|gtkhtml|gtksourceview|nautilusburn|rsvg|vte|wnck)
125     TARBALL="gnome-desktop-sharp"
126     add_depend "=dev-dotnet/gtk-sharp-${GTK_SHARP_REQUIRED_VERSION}*"
127 loki_val 1.21 add_depend "=dev-dotnet/gnome-sharp-2.24*"
128 pacho 1.33 add_depend "gnome-base/gnome-desktop:2"
129 loki_val 1.14 add_bdepend "=dev-dotnet/gtk-sharp-gapi-${GTK_SHARP_REQUIRED_VERSION}*"
130     ;;
131     *)
132     eerror "Huh? Sonny boy, looks like your GTK_SHARP_MODULE is not on the approved list. BAILING!"
133     die "How did we get here!!?"
134     ;;
135     esac
136 loki_val 1.8
137     case ${PF} in
138     #gtk-sharp tarball
139 loki_val 1.14 gtk-sharp-docs*)
140 moult 1.37 add_depend ">=dev-lang/mono-2.0"
141 loki_val 1.14 ;;
142 loki_val 1.8 gtk-sharp-gapi*)
143 loki_val 1.10 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
144 loki_val 1.8 add_depend "dev-perl/XML-LibXML"
145     ;;
146     gtk-sharp-*)
147 loki_val 1.14 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
148     add_depend "~dev-dotnet/glib-sharp-${PV}"
149 loki_val 1.8 add_depend "~dev-dotnet/atk-sharp-${PV}"
150     add_depend "~dev-dotnet/gdk-sharp-${PV}"
151     add_depend "~dev-dotnet/pango-sharp-${PV}"
152     ;;
153     gdk-sharp-*)
154 loki_val 1.14 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
155     add_depend "~dev-dotnet/glib-sharp-${PV}"
156 loki_val 1.8 add_depend "x11-libs/gtk+:2"
157     add_depend "~dev-dotnet/pango-sharp-${PV}"
158 loki_val 1.14 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
159 loki_val 1.8 ;;
160     atk-sharp-*)
161 loki_val 1.14 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
162     add_depend "~dev-dotnet/glib-sharp-${PV}"
163     add_depend "dev-libs/atk"
164 loki_val 1.8 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
165     ;;
166     glib-sharp-*)
167     add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
168     add_depend "dev-libs/glib:2"
169     ;;
170     pango-sharp-*)
171 loki_val 1.14 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
172     add_depend "~dev-dotnet/glib-sharp-${PV}"
173     add_depend "x11-libs/pango"
174 loki_val 1.8 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
175     ;;
176     gtk-dotnet-*)
177 loki_val 1.14 add_depend "~dev-dotnet/glib-sharp-${PV}"
178 loki_val 1.8 add_depend "~dev-dotnet/gdk-sharp-${PV}"
179     add_depend "~dev-dotnet/pango-sharp-${PV}"
180 loki_val 1.14 add_depend "~dev-dotnet/gtk-sharp-${PV}"
181     add_depend "dev-lang/mono[-minimal]"
182     add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
183 loki_val 1.8 ;;
184     glade-sharp-*)
185 loki_val 1.14 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
186     add_depend "~dev-dotnet/glib-sharp-${PV}"
187 loki_val 1.8 add_depend "~dev-dotnet/atk-sharp-${PV}"
188     add_depend "~dev-dotnet/gdk-sharp-${PV}"
189 loki_val 1.14 add_depend "~dev-dotnet/gtk-sharp-${PV}"
190 loki_val 1.8 add_depend "~dev-dotnet/pango-sharp-${PV}"
191 nirbheek 1.29 add_depend ">=gnome-base/libglade-2.3.6:2.0"
192 loki_val 1.8 ;;
193     #gnome-sharp tarball
194     art-sharp-*)
195     add_depend ">=media-libs/libart_lgpl-2.3.20"
196     ;;
197     gnome-sharp-*)
198     add_depend ">=gnome-base/libgnomeui-${PV_MAJOR}"
199     add_depend "~dev-dotnet/gnomevfs-sharp-${PV}"
200     add_depend "~dev-dotnet/art-sharp-${PV}"
201     add_depend ">=gnome-base/libgnomecanvas-${GNOMECANVAS_REQUIRED_VERSION}"
202 pacho 1.28 add_depend ">=x11-libs/gtk+-2.14.0:2"
203 loki_val 1.8 ;;
204     gconf-sharp-*)
205 nirbheek 1.29 add_depend ">=gnome-base/gconf-${PV_MAJOR}:2"
206 loki_val 1.21 add_depend "=dev-dotnet/glade-sharp-${GTK_SHARP_REQUIRED_VERSION}*"
207 loki_val 1.8 add_depend "~dev-dotnet/gnome-sharp-${PV}"
208     add_depend "~dev-dotnet/art-sharp-${PV}"
209     ;;
210     gnomevfs-sharp-*)
211 nirbheek 1.29 add_depend ">=gnome-base/gnome-vfs-${PV_MAJOR}:2"
212 loki_val 1.8 ;;
213     #gnome-desktop-sharp tarball
214     gnome-desktop-sharp-*)
215 loki_val 1.25 # NOTE: libgnome-desktop-2.so has been known to make binary-
216     # incompatible changes, requiring .so bumps. gnome-desktop-sharp
217     # is locked to a specific .so.n version, so strict dependencies
218     # may be required in the future (as it has in the past).
219 pacho 1.28 add_depend ">=gnome-base/gnome-desktop-${PV_MAJOR}:2"
220 loki_val 1.8 ;;
221     gnome-panel-sharp-*)
222 zmedico 1.17 add_depend ">=gnome-base/gnome-panel-${PV_MAJOR}"
223 loki_val 1.8 ;;
224     gnome-print-sharp-*)
225 loki_val 1.30 add_depend "gnome-base/libgnomeprint:2.2"
226     add_depend "gnome-base/libgnomeprintui:2.2"
227 loki_val 1.8 ;;
228     gtkhtml-sharp-*)
229     #NOTE: gtkhtml dependency must follow gtkhtml-sharp version.
230     #i.e. gtkhtml-sharp-2.24.0 >=gtkhtml-3.24
231     # gtkhtml-sharp-2.16.0 >=gtkhtml-3.16
232     # See bug 249540 for unpleasant side effects.
233 nirbheek 1.29 add_depend ">=gnome-extra/gtkhtml-$(($(get_version_component_range 1) + 1 )).$(get_version_component_range 2):3.14"
234 loki_val 1.8 ;;
235     gtksourceview-sharp-*)
236     add_depend ">=x11-libs/gtksourceview-${GTKSOURCEVIEW_REQUIRED_VERSION}:2.0"
237     ;;
238     nautilusburn-sharp-*)
239 loki_val 1.23 add_depend ">=gnome-extra/nautilus-cd-burner-2.24.0"
240 loki_val 1.8 ;;
241     rsvg-sharp-*)
242 pacho 1.28 add_depend ">=gnome-base/librsvg-${RSVG_REQUIRED_VERSION}:2"
243 loki_val 1.8 ;;
244     vte-sharp-*)
245 nirbheek 1.29 add_depend ">=x11-libs/vte-${VTE_REQUIRED_VERSION}:0"
246 loki_val 1.8 ;;
247     wnck-sharp-*)
248 nirbheek 1.29 add_depend ">=x11-libs/libwnck-${PV_MAJOR}:1"
249 loki_val 1.8 ;;
250     esac
251    
252 loki_val 1.14 # @ECLASS-VARIABLE: DESCRIPTION
253     # @DESCRIPTION:
254     # Default value: GtkSharp's ${GTK_SHARP_MODULE} module of the ${TARBALL} tarball
255     DESCRIPTION="GtkSharp's ${GTK_SHARP_MODULE} module of the ${TARBALL} tarball"
256     # @ECLASS-VARIABLE: HOMEPAGE
257     # @DESCRIPTION:
258     # Default value: http://www.mono-project.com/GtkSharp
259     HOMEPAGE="http://www.mono-project.com/GtkSharp"
260 vapier 1.34 # @ECLASS-VARIABLE: LICENSE
261 loki_val 1.14 # @DESCRIPTION:
262     # Default value: LGPL-2.1
263     LICENSE="LGPL-2.1"
264 loki_val 1.8
265 loki_val 1.14 add_depend ">=dev-lang/mono-2.0.1"
266     add_bdepend ">=sys-apps/sed-4"
267 jdhore 1.35 add_bdepend "virtual/pkgconfig"
268 loki_val 1.14 add_bdepend ">=app-shells/bash-3.1"
269 loki_val 1.8
270 loki_val 1.14 IUSE="debug"
271 loki_val 1.19 # @ECLASS-VARIABLE: S
272 loki_val 1.14 # @DESCRIPTION:
273     # Default value: ${WORKDIR}/${TARBALL}-${PV}
274     S="${WORKDIR}/${TARBALL}-${PV}"
275     # @ECLASS-VARIABLE: SRC_URI
276     # @DESCRIPTION:
277     # Default value: mirror://gnome/sources/${TARBALL}/${PV_MAJOR}/${TARBALL}-${PV}.tar.bz2
278     SRC_URI="${SRC_URI}
279     mirror://gnome/sources/${TARBALL}/${PV_MAJOR}/${TARBALL}-${PV}.tar.bz2"
280    
281     # @FUNCTION: get_sharp_apis
282     # @USAGE: <type> <pkgconfig-package>
283     # @RETURN: .NET API files
284     # @DESCRIPTION:
285     # Given a valid pkg-config package, will return a list of API xml files.
286     # <type> can be either --prefixed or --bare. If prefixed, each API file
287     # will be prefixed with -I:
288     get_sharp_apis() {
289     [[ ${#@} -eq 2 ]] || die "${FUNCNAME} needs two arguments"
290     get_sharp_assemblies "$@"
291     }
292    
293     # @FUNCTION: get_sharp_assemblies
294     # @USAGE: <type> <pkgconfig-package>
295     # @RETURN: .NET .dll assemblies
296     # @DESCRIPTION:
297     # Given a valid pkg-config package, will return a list of .dll assemblies.
298     # <type> can be either --prefixed or --bare. If prefixed, each .dll file
299     # will be prefixed with -r:
300     get_sharp_assemblies() {
301     [[ ${#@} -eq 2 ]] || die "${FUNCNAME} needs two arguments"
302     local string config=libs prefix="-r:"
303     local -a rvalue
304     [[ "${FUNCNAME[1]}" = "get_sharp_apis" ]] && config=cflags && prefix="-I:"
305     for string in $(pkg-config --${config} ${2} 2> /dev/null)
306 loki_val 1.8 do
307 loki_val 1.14 rvalue+=( ${string#-?:} )
308 loki_val 1.8 done
309 loki_val 1.14
310     case $1 in
311     --bare)
312     :
313     ;;
314     --prefixed)
315     for (( i=0 ; i< ${#rvalue[@]} ; i++ ))
316     do
317     rvalue[$i]=${prefix}${rvalue[$i]}
318     done
319     ;;
320     *)
321     die "${FUNCNAME}: Unknown parameter"
322     ;;
323     esac
324     echo "${rvalue[@]}"
325     }
326    
327     # @FUNCTION: phase_hook
328     # @USAGE: <prefix>
329 vapier 1.32 # @DESCRIPTION:
330 loki_val 1.14 # Looks for functions named <prefix>_caller_suffix and executes them.
331     # _caller_suffix is the calling function with the prefix
332     # gtk-sharp-module removed.
333     phase_hook() {
334     [[ ${#@} -eq 1 ]] || die "${FUNCNAME} needs one argument"
335     if [[ "$(type -t ${1}${FUNCNAME[1]#gtk-sharp-module})" = "function" ]]
336     then
337     ebegin "Phase-hook: Running ${1}${FUNCNAME[1]#gtk-sharp-module}"
338     ${1}${FUNCNAME[1]#gtk-sharp-module}
339     eend 0
340     fi
341 loki_val 1.8 }
342    
343 loki_val 1.14 # @FUNCTION: ac_path_prog_override
344     # @USAGE: <PROG> [path]
345     # @DESCRIPTION:
346     # Override AC_PATH_PROG() autoconf macros. Path will be set to " " if
347     # not specified.
348     ac_path_prog_override() {
349     if [[ ${#@} -lt 1 || ${#@} -gt 2 ]]
350 loki_val 1.8 then
351 loki_val 1.14 eerror "${FUNCNAME[0]} requires at least one parameter and takes at most two:"
352     eerror "AC_PATH_PROG(PARAM1, param2)"
353     die "${FUNCNAME[0]} requires at least one parameter and takes at most two:"
354 loki_val 1.8 fi
355 loki_val 1.14 export ac_cv_path_${1}="${2:- }"
356 loki_val 1.8 }
357    
358 loki_val 1.14
359     # @FUNCTION: pkg_check_modules_override
360     # @USAGE: <GROUP> [package1] [package2]
361     # @DESCRIPTION:
362     # Will export the appropriate variables to override PKG_CHECK_MODULES autoconf
363     # macros, with the string " " by default. If packages are specified, they will
364     # be looked up with pkg-config and the appropriate LIBS and CFLAGS substituted.
365     # LIBS and CFLAGS can also be specified per-package with the following syntax:
366     # @CODE
367     # package=LIBS%CFLAGS
368     # @CODE
369     # = and % have no effect unless both are specified.
370     # Here is an example:
371     # @CODE
372     # pkg_check_modules_override GASH "gtk+-2.0=-jule%" gobject-2.0
373     # @CODE
374     # The above example will do:
375     # export GASH_CFLAGS+=" -jule"
376     # export GASH_LIBS+=" "
377     # export GASH_CFLAGS+=" $(pkg-config --cflags gobject-2.0)"
378     # export GASH_LIBS+=" $(pkg-config --libs gobject-2.0)"
379     #
380     # NOTE: If a package is not found, the string " " will be inserted in place of
381     # <GROUP>_CFLAGS and <GROUP>_LIBS
382     pkg_check_modules_override() {
383     local package
384     local group="${1}"
385     local packages="${*:2}"
386     export ${group}_CFLAGS=" "
387     export ${group}_LIBS=" "
388    
389     if [[ ${#@} -lt 1 ]]
390 loki_val 1.8 then
391 loki_val 1.14 eerror "${FUNCNAME[0]} requires at least one parameter: GROUP"
392     eerror "PKG_CHECK_MODULES(GROUP, package1 package2 etc)"
393     die "${FUNCNAME[0]} requires at least one parameter: GROUP"
394 loki_val 1.8 fi
395 loki_val 1.1
396 loki_val 1.14 for package in $packages
397     do
398     if [[ ${package/=} != ${package} && ${package/\%} != ${package} ]]
399     then
400     package_cflag_libs=${package##*=}
401     export ${group}_CFLAGS+=" ${package_cflag_libs%%\%*}"
402     export ${group}_LIBS+=" ${package_cflag_libs##*\%}"
403     else
404     if pkg-config --exists $package
405     then
406     export ${group}_CFLAGS+=" $(pkg-config --cflags $package)"
407     export ${group}_LIBS+=" $(pkg-config --libs $package)"
408     else
409     export ${group}_CFLAGS+=" "
410     export ${group}_LIBS+=" "
411     fi
412     fi
413     done
414     }
415 loki_val 1.1
416 loki_val 1.14 # @FUNCTION: gtk-sharp-tarball-post_src_prepare
417     # @DESCRIPTION:
418     # Runs a M-m-m-monster sed on GTK_SHARP_MODULE_DIR to convert references to
419     # local assemblies to the installed ones. Is only called by src_prepare when
420     # $GTK_SHARP_MODULE is a member of $gtk_sharp_module_list.
421     gtk-sharp-tarball-post_src_prepare() {
422 darkside 1.31 has "${EAPI:-0}" 2 && ! use prefix && EPREFIX=
423 loki_val 1.6 cd "${S}/${GTK_SHARP_MODULE_DIR}"
424 loki_val 1.14 sed -i \
425     -e "s; \$(srcdir)/../glib/glib-api.xml; $(get_sharp_apis --bare glib-sharp-2.0);" \
426     -e "s; ../pango/pango-api.xml; $(get_sharp_apis --bare pango-sharp-2.0);" \
427     -e "s; ../atk/atk-api.xml; $(get_sharp_apis --bare atk-sharp-2.0);" \
428     -e "s; ../gdk/gdk-api.xml; $(get_sharp_apis --bare gdk-sharp-2.0);" \
429     -e "s; ../gtk/gtk-api.xml; $(get_sharp_apis --bare gtk-sharp-2.0);" \
430     -e "s; \.\./glib/glib-sharp.dll; $(get_sharp_assemblies --bare glib-sharp-2.0);g" \
431     -e "s; \.\./pango/pango-sharp.dll; $(get_sharp_assemblies --bare pango-sharp-2.0);g" \
432     -e "s; \.\./atk/atk-sharp.dll; $(get_sharp_assemblies --bare atk-sharp-2.0);g" \
433     -e "s; \.\./gdk/gdk-sharp.dll; $(get_sharp_assemblies --bare gdk-sharp-2.0);g" \
434     -e "s; \.\./gtk/gtk-sharp.dll; $(get_sharp_assemblies --bare gtk-sharp-2.0);g" \
435 darkside 1.31 -e "s;\$(RUNTIME) \$(top_builddir)/parser/gapi-fixup.exe;${EPREFIX}/usr/bin/gapi2-fixup;" \
436     -e "s;\$(RUNTIME) \$(top_builddir)/generator/gapi_codegen.exe;${EPREFIX}/usr/bin/gapi2-codegen;" \
437 loki_val 1.14 -e "s:\$(SYMBOLS) \$(top_builddir)/parser/gapi-fixup.exe:\$(SYMBOLS):" \
438     -e "s:\$(INCLUDE_API) \$(top_builddir)/generator/gapi_codegen.exe:\$(INCLUDE_API):" \
439     $(find . -name Makefile.in) || die "failed to fix ${TARBALL}-tarball makefiles"
440     }
441    
442     # @FUNCTION: gnome-sharp-tarball-post_src_prepare
443     # @DESCRIPTION:
444     # Runs a M-m-m-monster sed on GTK_SHARP_MODULE_DIR to convert references to
445     # local assemblies to the installed ones. Is only called by src_prepare when
446     # $GTK_SHARP_MODULE is a member of $gnome_sharp_module_list.
447     gnome-sharp-tarball-post_src_prepare() {
448     cd "${S}/${GTK_SHARP_MODULE_DIR}"
449     sed -i \
450     -e "s; ../gnomevfs/gnome-vfs-api.xml; $(get_sharp_apis --bare gnome-vfs-sharp-2.0);" \
451     -e "s; ../art/art-api.xml; $(get_sharp_apis --bare art-sharp-2.0);" \
452     -e "s; \.\./art/art-sharp.dll; $(get_sharp_assemblies --bare art-sharp-2.0);g" \
453     -e "s; \.\./gnomevfs/gnome-vfs-sharp.dll; $(get_sharp_assemblies --bare gnome-vfs-sharp-2.0);g" \
454     -e "s;/r:\$(top_builddir)/art/art-sharp.dll;$(get_sharp_assemblies --prefixed art-sharp-2.0);" \
455     -e "s;/r:\$(top_builddir)/gnome/gnome-sharp.dll;$(get_sharp_assemblies --prefixed gnome-sharp-2.0);" \
456     $(find . -name Makefile.in) || die "failed to fix ${TARBALL}-tarball makefiles"
457     }
458    
459     # @FUNCTION: gtk-sharp-module_src_prepare
460     # @DESCRIPTION:
461     # Runs autopatch from base.eclass, eautoreconf if EAUTORECONF is set to any
462     # value.
463     # Contains a phase_hook, runs very last.
464     # phase_hook prefix trigger: ${TARBALL}-tarball-post
465     # Is exported.
466     gtk-sharp-module_src_prepare() {
467 scarabeus 1.26 base_src_prepare
468 loki_val 1.14 # @ECLASS-VARIABLE: EAUTORECONF
469     # @DESCRIPTION:
470     # If set, EAUTORECONF will be run during src_prepare.
471     [[ ${EAUTORECONF} ]] && eautoreconf
472     phase_hook ${TARBALL}-tarball-post
473 loki_val 1.24 elibtoolize
474 loki_val 1.1 }
475    
476 loki_val 1.14 # @FUNCTION: gtk-sharp-tarball_src_configure
477     # @DESCRIPTION:
478     # Sets some environment variables that will allow us to make the dependencies
479     # for each ebuild be only its own dependencies, without patching configure.
480     # Is only called by gtk-sharp-module_src_configure when $GTK_SHARP_MODULE
481     # is a member of $gtk_sharp_module_list.
482     gtk-sharp-tarball_src_configure() {
483     pkg_check_modules_override GLIB gobject-2.0
484     pkg_check_modules_override GIO gio-2.0
485     pkg_check_modules_override PANGO pango
486     pkg_check_modules_override ATK atk
487     pkg_check_modules_override GTK gtk+-2.0
488     pkg_check_modules_override GLADE libglade-2.0
489     }
490    
491     # @FUNCTION: gnome-sharp-tarball_src_configure
492     # @DESCRIPTION:
493     # Sets some environment variables that will allow us to make the dependencies
494     # for each ebuild be only its own dependencies. Without patching configure.
495     # Is only called by gtk-sharp-module_src_configure when $GTK_SHARP_MODULE
496     # is a member of $gnome_sharp_module_list.
497     gnome-sharp-tarball_src_configure() {
498 darkside 1.31 has "${EAPI:-0}" 2 && ! use prefix && EPREFIX=
499 loki_val 1.14 pkg_check_modules_override GLADESHARP glade-sharp-2.0
500     pkg_check_modules_override GAPI gapi-2.0
501 darkside 1.31 ac_path_prog_override GAPI_PARSER "${EPREFIX}"/usr/bin/gapi2-parser
502     ac_path_prog_override GAPI_CODEGEN "${EPREFIX}"/usr/bin/gapi2-codegen
503     ac_path_prog_override GAPI_FIXUP "${EPREFIX}"/usr/bin/gapi2-fixup
504 loki_val 1.14 }
505    
506     # @FUNCTION: gtk-sharp-module_src_configure
507     # @USAGE: [econf-arguments]
508     # @DESCRIPTION:
509     # Calls econf with some default values.
510     # Contains a phase_hook, run before econf.
511     # phase_hook prefix trigger: ${TARBALL}-tarball
512     # Is exported.
513 loki_val 1.1 gtk-sharp-module_src_configure() {
514 loki_val 1.14 phase_hook ${TARBALL}-tarball
515 loki_val 1.8 econf --disable-static \
516     --disable-dependency-tracking \
517     --disable-maintainer-mode \
518     $(use debug &&echo "--enable-debug" ) \
519     ${@} || die "econf failed"
520 loki_val 1.1 }
521    
522 loki_val 1.14 # @FUNCTION: gtk-sharp-module_src_compile
523     # @DESCRIPTION:
524     # Calls emake in the subdir of the module.
525     # Sets CSC=/usr/bin/gmcs. Deletes top_srcdir Makefiles to prevent recursing in
526     # case we missed some dll references.
527     # Is exported.
528 loki_val 1.1 gtk-sharp-module_src_compile() {
529 loki_val 1.14 rm -f "${S}"/Makefile* &> /dev/null
530 loki_val 1.6 cd "${S}/${GTK_SHARP_MODULE_DIR}"
531 loki_val 1.14 emake CSC=/usr/bin/gmcs || die "emake failed"
532 loki_val 1.1 }
533    
534 loki_val 1.14 # @FUNCTION: gtk-sharp-module_src_install
535     # @DESCRIPTION:
536     # Installs the module. Fixes up lib paths so they're multilib-safe.
537     # Gets rid of .la files.
538     # Is exported.
539 loki_val 1.1 gtk-sharp-module_src_install() {
540 loki_val 1.12 cd "${S}/${GTK_SHARP_MODULE_DIR}"
541 loki_val 1.14 emake DESTDIR="${D}" install || die "emake install failed"
542 loki_val 1.8 mono_multilib_comply
543 loki_val 1.14 find "${D}" -type f -name '*.la' -exec rm -rf '{}' '+' || die "la removal failed"
544     [[ $(find "${D}" -type f|wc -l) -lt 3 ]] && die "Too few files. This smells like a failed install."
545 loki_val 1.1 }
546    
547     EXPORT_FUNCTIONS src_prepare src_configure src_compile src_install

  ViewVC Help
Powered by ViewVC 1.1.20